apiVersion: v1
kind: ConfigMap
metadata:
  name: {{ template "fullname" . }}
  namespace: {{ $.Release.Namespace }}
  labels:
    {{- include "gitlab.standardLabels" . | nindent 4 }}
    {{- include "gitlab.commonLabels" . | nindent 4 }}
  annotations:
data:
  config.erb: |
    {{- with .Values.gitlabCache }}
    {{- if .cleanup }}
    gitlab-cache-cleanup={{ .cleanup }}
    {{- end }}
    {{- if .expiry }}
    gitlab-cache-expiry={{ .expiry }}
    {{- end }}
    {{- if .refresh }}
    gitlab-cache-refresh={{ .refresh }}
    {{- end }}
    {{- end }}
    {{- with .Values.gitlabRetrieval }}
    {{- if .interval }}
    gitlab-retrieval-interval={{ .interval }}
    {{- end }}
    {{- if .retries }}
    gitlab-retrieval-retries={{ .retries }}
    {{- end }}
    {{- if .timeout }}
    gitlab-retrieval-timeout={{ .timeout }}
    {{- end }}
    {{- end }}
    {{- if not (empty .Values.headers) }}
    {{- $headers := .Values.headers | join ";;" }}
    header={{ $headers }}
    {{- end }}
    {{- $externalAddresses := concat $.Values.global.pages.externalHttp $.Values.global.pages.externalHttps | uniq }}
    {{- if (empty ($externalAddresses)) }}
    listen-proxy=0.0.0.0:{{ .Values.service.internalPort }}
    {{- else }}
      {{- if not (empty $.Values.global.pages.externalHttp) }}
    listen-http=0.0.0.0:{{ .Values.service.internalPort }}
      {{- end }}
      {{- if not (empty $.Values.global.pages.externalHttps) }}
    listen-https=0.0.0.0:{{ .Values.service.customDomains.internalHttpsPort }}
    root-cert=/etc/gitlab-secrets/pages/{{ template "gitlab.pages.hostname" $ }}.crt
    root-key=/etc/gitlab-secrets/pages/{{ template "gitlab.pages.hostname" $ }}.key
      {{- end }}
    {{- end }}
    {{- if .Values.propagateCorrelationId }}
    propagate-correlation-id={{ .Values.propagateCorrelationId }}
    {{- end }}
    pages-domain={{ template "gitlab.pages.hostname" . }}
    pages-root=/srv/gitlab-pages
    log-format={{ .Values.logFormat }}
    log-verbose={{ eq .Values.logVerbose true }}
    redirect-http={{ eq .Values.redirectHttp true }}
    use-http2={{ eq .Values.useHttp2 true }}
    insecure-ciphers={{ eq .Values.insecureCiphers true }}
    artifacts-server={{ template "gitlab.pages.artifactsServer" . }}
    artifacts-server-timeout={{ default 10 .Values.artifactsServerTimeout }}
    gitlab-server={{ template "gitlab.pages.gitlabServer" . }}
    internal-gitlab-server={{ template "gitlab.pages.internalGitlabServer" . }}
    api-secret-key=/etc/gitlab-secrets/pages/secret
    domain-config-source={{ default "gitlab" .Values.domainConfigSource }}
    {{- if and .Values.metrics.enabled .Values.metrics.port }}
    metrics-address=:{{ .Values.metrics.port | int }}
    {{- end }}
    {{- if .Values.maxConnections }}
    max-conns={{ .Values.maxConnections }}
    {{- end }}
    {{- if .Values.gitlabClientHttpTimeout }}
    gitlab-client-http-timeout={{ .Values.gitlabClientHttpTimeout }}
    {{- end }}
    {{- if .Values.gitlabClientJwtExpiry }}
    gitlab-client-jwt-expiry={{ .Values.gitlabClientJwtExpiry }}
    {{- end }}
    {{- if .Values.sentry.enabled }}
    {{-   if .Values.sentry.dsn }}
    sentry-dsn={{ .Values.sentry.dsn }}
    {{-   end }}
    {{-   if .Values.sentry.environment }}
    sentry-environment={{ .Values.sentry.environment }}
    {{-   end }}
    {{- end }}
    {{- if .Values.statusUri }}
    pages-status={{ .Values.statusUri }}
    {{- end }}
    {{- if .Values.tls.minVersion }}
    tls-min-version={{ .Values.tls.minVersion }}
    {{- end }}
    {{- if .Values.tls.maxVersion }}
    tls-max-version={{ .Values.tls.maxVersion }}
    {{- end }}
    {{- if eq $.Values.global.pages.accessControl true }}
    auth-redirect-uri={{ template "oauth.gitlab-pages.authRedirectUri" . }}
    auth-client-id=<%= File.read('/etc/gitlab-secrets/pages/gitlab_appid').strip.dump[1..-2] %>
    auth-client-secret=<%= File.read('/etc/gitlab-secrets/pages/gitlab_appsecret').strip.dump[1..-2] %>
    auth-secret=<%= File.read('/etc/gitlab-secrets/pages/auth_secret').strip.dump[1..-2] %>
    {{- end }}
    {{- with .Values.zipCache }}
    {{- if .cleanup }}
    zip-cache-cleanup={{ .cleanup }}
    {{- end }}
    {{- if .expiration }}
    zip-cache-expiration={{ .expiration }}
    {{- end }}
    {{- if .refresh }}
    zip-cache-refresh={{ .refresh }}
    {{- end }}
    {{- end }}
    {{- if .Values.zipOpenTimeout }}
    zip-open-timeout={{ .Values.zipOpenTimeout }}
    {{- end }}
  configure: |
    {{- include "gitlab.scripts.configure.secrets" (dict "required" "pages" "optional" "pages") | nindent 4 -}}
